> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/android/changelogs/version-10/v10-1-0.md).

# Version 10.1.0 Changelog (May 10, 2023)

World's #1 PDF SDK Library for Web, Mobile, Server, Desktop

Version: 10.1.0.81989

Release Date: May 10, 2023

## New features

* Add Close All Tabs feature
* Update pan tool quick menu order
* Add some German translations

## Fixed

* Fix issue where custom appearance on Free Text is lost on paste
* Fix issue where writing with a stylus on the slider would shift the ink annotation
* Fix issue where zooming when the ink tool is selected leaves a fake dot behind
* Fix issue with line ending styling not appearing correctly
* Fix issue with the color mode of the view mode dialog being out of sync with PDFViewCtrl

## APIs

### PDFViewCtrlTools package

#### PdfViewCtrlTabBaseFragment

*new* method: `String getPassword()`

#### PdfViewCtrlTabHostBaseFragment

*new* method: `void closeAllTabs(boolean)`

#### ViewModePickerDialogFragment

*new* static method: `ViewModePickerDialogFragment newInstance(PagePresentationMode, int, boolean, boolean, int, ArrayList<Integer>)`

#### Type

*new* static final field: `Type CLOSE_ALL_TABS`

#### TabSwitcherViewModel

*new* method: `void onCloseAllTabs()`

#### InkItem

*new* method: `void clearCurrentActiveStroke()`

#### LineCreate

*new* static method: `void calculateLineEndingStyle(LineEndingStyle, LineEndingStyle, PointF, PointF, PointF, PointF, PointF, PointF, float, double, LineEndingCalculationVariables)`

*removed* static method: `void calculateLineEndingStyle(LineEndingStyle, PointF, PointF, PointF, PointF, PointF, PointF, float, double)`

#### DrawingUtils

*new* static method: `void calButt(PointF, PointF, LineEndingCalculationVariables)`

*new* static method: `void calcCircle(PointF, PointF, PointF, LineEndingCalculationVariables)`

*new* static method: `void calcClosedArrow(PointF, PointF, PointF, LineEndingCalculationVariables)`

*new* static method: `void calcDiamond(PointF, PointF, PointF, PointF, LineEndingCalculationVariables)`

*new* static method: `void calcOpenArrow(PointF, PointF, PointF, LineEndingCalculationVariables)`

*new* static method: `void calcRClosedArrow(PointF, PointF, PointF, LineEndingCalculationVariables)`

*new* static method: `void calcROpenArrow(PointF, PointF, PointF, LineEndingCalculationVariables)`

*new* static method: `void calcSlash(PointF, PointF, LineEndingCalculationVariables)`

*new* static method: `void calcSquare(PointF, PointF, LineEndingCalculationVariables)`

*removed* static method: `void calButt(PointF, PointF, PointF, PointF, float, double)`

*removed* static method: `void calcCircle(PointF, PointF, PointF, float, double)`

*removed* static method: `void calcClosedArrow(PointF, PointF, PointF, PointF, float, double)`

*removed* static method: `void calcDiamond(PointF, PointF, PointF, PointF, PointF, float, double)`

*removed* static method: `void calcOpenArrow(PointF, PointF, PointF, PointF, float, double)`

*removed* static method: `void calcRClosedArrow(PointF, PointF, PointF, PointF, float, double)`

*removed* static method: `void calcROpenArrow(PointF, PointF, PointF, PointF, float, double)`

*removed* static method: `void calcSlash(PointF, PointF, PointF, PointF, float, double)`

*removed* static method: `void calcSquare(PointF, PointF, PointF, PointF, PointF, PointF, float, double)`

#### LineEndingCalculationVariables

*new* class: `LineEndingCalculationVariables`

*new* constructor: `LineEndingCalculationVariables(PointF, PointF, float, double, LineEndingStyle, LineEndingStyle, boolean)`

*new* field: `Vec2 current`

*new* field: `Vec2 end`

*new* field: `double len`

*new* field: `Vec2 line`

*new* field: `Vec2 line90`

*new* field: `double sqrt2`

*new* field: `double sqrt3`

#### ToolbarActionMode

*new* method: `Toolbar getMainToolbar()`

*new* method: `Toolbar getToolbar()`

#### Utils

*new* static field: `boolean sTEST_MODE`

#### Vec2

*new* static method: `Vec2 divide(Vec2, Vec2)`

*new* static method: `Vec2 divide(Vec2, double)`

*modified* method: `void normalize()`

|       | Declaration             |
| ----- | ----------------------- |
| From: | public void normalize() |
| To:   | public Vec2 normalize() |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.apryse.com/android/changelogs/version-10/v10-1-0.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
